/******************************************************************************/
/* Blinky.c: LED Flasher and graphic demo                                     */
/******************************************************************************/
/* This file is part of the uVision/ARM development tools.                    */
/* Copyright (c) 2005-2009 Keil Software. All rights reserved.                */
/* This software may only be used under the terms of a valid, current,        */
/* end user licence from KEIL for a compatible version of KEIL software       */
/* development tools. Nothing else gives you the right to use this software.  */
/******************************************************************************/                  
#include <LPC17xx.H>                    				//NXP LPC17xx definitions 
#include "LCD.h"
#include "string.h"
#include "sys.h"
#include "lcd.h"
#include "touch.h"
#include "exti.h"
#include "M45PE161.h"
#include "text.h"
#include "MMC_SD.h"
#include "FAT.h"
#include "fontupd.h"
#include "delay.h"
#include "ssp0.h"
#include "jpegbmp.h"

#define  M45PE16_FLASH_ID    0x4015
volatile unsigned long FLASH_ID = 0;
const unsigned char *sysfile[4]=
{			  
"0.BMP",
"4.BMP",
"320_216.BMP",
"1.BMP",	  
};
/*
*********************************************************************************************************
* Description: 	The function is setting font colorsbrush colors and the area of clear
* Arguments  : 	None
* Returns    : 	None
*********************************************************************************************************
*/
void Load_Drow_Dialog(void)
{
	LCD_Clear(WHITE);   
 	POINT_COLOR=Red;									//Setting font colors 
	LCD_ShowString(216,0,"RST");						//Displaying screen clear area
  	POINT_COLOR=RED;									//Setting brush color 
}

/*
*********************************************************************************************************
* Description: 	Main function
* Arguments  : 	None
* Returns    : 	None
*********************************************************************************************************
*/
int main (void)                       
{
		  
	u16 i;
	FileInfoStruct *FileInfo1;
	FileInfoStruct F_Info1[3];
//	BYTE *PIC_Name;
//	FileInfoStruct FileTemp;
	u32 temp_cluster;
	SystemInit();
	SPIx_Init();
	LCD_Init();
	ssp0_init(); //SPIʼ

	Load_Drow_Dialog();
	FLASH_ID = SPI_Flash_ReadID();/* M45PE161ֵΪ204515H(ʮ)    2113557D ʮƣ  */
	Font_Init();		 
	
		POINT_COLOR=Blue;      
		LCD_Clear(WHITE);
		LCD_ShowString(60,30,"www.OpenMCU.com");
		POINT_COLOR=RED;      
		Show_Str(60,50,"NXP1768",16,0);				    	 
		Show_Str(60,70,"ͼƬʾ",16,0);				    	 
		Show_Str(60,90,"ķ",16,0);				    	 
		Show_Str(60,110,"20101215",16,0);			 
	
		// 
		SD_Init();		 //ʼSD
	 	while(FAT_Init())//FAT 
		{
			LCD_ShowString(60,150,"FAT SYS ERROR");  
			i= SD_Init();
			if(i)//SDʼ 
			{						  
				LCD_ShowString(60,170,"SD_CARD ERROR");
			}	  
			delay_ms(500);
			LCD_Fill(60,90,240,126,WHITE);//ʾ			  
			delay_ms(500);  
		}
  		LCD_ShowString(60,130,"FAT SYS OK!"); 
		Show_Str(60,170,"ͼƬȡ...",16,0);			
	 	while(PIC_Display()!=0)//³
		{						  
			LCD_ShowString(60,170,"SYSTEM FILE LOST");		  
			delay_ms(500);    
			LCD_ShowString(60,170,"Please Check....");
			delay_ms(500);    
		};
					 
		LCD_Clear(WHITE);
		temp_cluster = PIC_Cluster;
		FileInfo1=&F_Info1[0];//ݴռ.
 		while(1)
		{
			for(i=1;i<5;i++)
			{
					Get_File_Info(temp_cluster,FileInfo1,T_JPEG|T_JPG|T_BMP,&i);		
					LCD_Clear(White);	
			 		AI_LoadPicFile(FileInfo1,0,0,240,320);//ʾͼƬ
					POINT_COLOR = Red;
					Show_Str(0,0,FileInfo1->F_Name,16,1);	 	
					delay_ms(300);		
			}
		 }
}


